<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.4.0-12                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2014-11-26 09:11:40 Boant info@boant.ru Exp $ */
//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php";

function _moduleContent(&$smarty, $module_name)
{
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoCalls_disconnector.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    //conexion resource
    //$pDB = new paloDB($arrConf['dsn_conn_database']);
    $pDB = "";

    //actions
    $action = getAction();
    $content = "";

    switch($action){
        case "do_selected":
            $content = DoSelectedCalls_disconnector($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        case "disconnect_one":
            $content = DoSelectedCalls_disconnector($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        case "refresh":
            $content = viewFormCalls_disconnector($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
        default: // view_form
            $content = viewFormCalls_disconnector($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
            break;
    }
    return $content;
}

function viewFormCalls_disconnector($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $pCalls_disconnector = new paloSantoCalls_disconnector($pDB);
    $arrFormCalls_disconnector = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormCalls_disconnector);

    //begin, Form data persistence to errors and other events.
    $_DATA  = $_POST;
    $action = getParameter("action");
    $id     = getParameter("id");
    $smarty->assign("ID", $id); //persistence id with input hidden in tpl

    if($action=="view")
        $oForm->setViewMode();
    else if($action=="view_edit" || getParameter("save_edit"))
        $oForm->setEditMode();
    //end, Form data persistence to errors and other events.

    if($action=="view" || $action=="view_edit"){ // the action is to view or view_edit.
        $dataCalls_disconnector = $pCalls_disconnector->getCalls_disconnectorById($id);
        if(is_array($dataCalls_disconnector) & count($dataCalls_disconnector)>0)
            $_DATA = $dataCalls_disconnector;
        else{
            $smarty->assign("mb_title", _tr("Error get Data"));
            $smarty->assign("mb_message", $pCalls_disconnector->errMsg);
        }
    }

    createCurrentConnections($smarty);
    $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl",_tr("Calls Disconnector"), $_DATA);
    $content = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";

    return $content;
}

function DoSelectedCalls_disconnector($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf)
{
    $pCalls_disconnector = new paloSantoCalls_disconnector($pDB);
    $arrFormCalls_disconnector = createFieldForm();
    $oForm = new paloForm($smarty,$arrFormCalls_disconnector);

    if(!$oForm->validateForm($_POST)){
        // Validation basic, not empty and VALIDATION_TYPE 
        $smarty->assign("mb_title", _tr("Validation Error"));
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v)
                $strErrorMsg .= "$k, ";
        }
        $smarty->assign("mb_message", $strErrorMsg);
        $content = viewFormCalls_disconnector($smarty, $module_name, $local_templates_dir, $pDB, $arrConf);
    }
    else{
        //NO ERROR, HERE IMPLEMENTATION OF SAVE
        //$content = "Code to save yet undefined.";
	$action = getAction();
	$acall_id = array();
        switch($action){
	    case "do_selected":
		$adisc_id = getParameter("selection");
		foreach($adisc_id as $call_id) {
		    $acall_id[] = $call_id;
		}
    	        break;
            case "disconnect_one":
		$adisc_id = getParameterRegexp("disc_.*");
    		if (count($adisc_id) > 0) {
    	    	    $acall_id[] = getParameter('id'.$adisc_id[0]['key']);
    		}
        	break;
	}
	$acmd = array();
	foreach($acall_id as $call_id) {
    		$cmd = 'channel request hangup '.ereg_replace('[^0-9.a-zA-Z]','',$call_id);
    		$clires = runAsteriskCLI($cmd);
    		$acmd[] = array('cmd' => $cmd, 'result' => implode(';',$clires));
    	}
	$smarty->assign('DISCONNECTIONS',_tr('Disconnection results'));
	$smarty->assign('DISCCOMMAND',_tr('Disconnection command'));
	$smarty->assign('DISCRESULT',_tr('Disconnection result'));
	$smarty->assign('disc_res',$acmd);
	createCurrentConnections($smarty);
        $htmlForm = $oForm->fetchForm("$local_templates_dir/form.tpl",_tr("Calls Disconnector"), $_DATA);
	$content = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm."</form>";
    }
    return $content;
}

/* Make Array with current Asterisk's conversations */
function createCurrentConnections($smarty) {
    $smarty->assign("CANCEL", _tr("Cancel"));
    $smarty->assign("REQUIRED_FIELD", _tr("Required field"));
    $smarty->assign("icon", "images/list.png");

    $smarty->assign("DOSELECTED", _tr("Disconnect Selected"));
    $smarty->assign("REFRESH", _tr("Refresh"));
    $smarty->assign("DISCONNECT", _tr("Disconnect"));
    $smarty->assign(array(
	"CALL_SELECT" => _tr("Call Select"),
	"CALL_ID" => _tr("Call ID"),
	"CALL_FROM" => _tr("Call From"),
	"CALL_PROGRAM" => _tr("Call Program"),
	"CALL_STATE" => _tr("Call State"),
	"CALL_CONTEXT" => _tr("Call Context"),
	"CALL_CHANNEL" => _tr("Call Channel"),
	"CALL_CHANNELDEST" => _tr("Call Channel Destination"),
	"CALL_DURATION" => _tr("Call Duration"),
	"CALL_ACODE" => _tr("Call Account Code"),
	"CALL_ACODEDEST" => _tr("Call Account Code Destination"),
	));

    /* Get list of current conversations */
    $lines = runAsteriskCLI("core show channels concise");
    $arrCalls = array();
    foreach ($lines as $rawline) {
	$line = explode('!',$rawline);
        if (count($line) >= 14) {
          $callid = ''.$line[13];
          $sortid = 'd'.substr('0000000000'.$line[11],-10,10);
          $arrCalls[$callid] = array();
          $arrCalls[$callid]['ID'] = ereg_replace('[^0-9.a-zA-Z]','',$callid);
          $arrCalls[$callid]['disc_ID'] = 'disc_'.ereg_replace('[^0-9]','',$callid);
          $arrCalls[$callid]['FROM'] = $line[7];
          $arrCalls[$callid]['PROGRAM'] = $line[2];
          $arrCalls[$callid]['STATE'] = $line[4];
          $arrCalls[$callid]['CONTEXT'] = $line[1];
          $arrCalls[$callid]['CHANNEL'] = $line[0];
          $arrCalls[$callid]['CHANNELDEST'] = $line[12];
          $arrCalls[$callid]['DURATION'] = $line[11];
          $arrCalls[$callid]['ACODE'] = $line[9];
          $arrCalls[$callid]['ACODEDEST'] = $line[10];
          }
    }
   
    $smarty->assign("CALLS", implode(';',$lines));
    if (count($arrCalls) < 1) {
      $arrCalls['c0'] = array(
	"ID" => '-',
	);
      $smarty->assign("NOACTIVE", _tr("No Active Calls"));
    } else {
      ksort($arrCalls);
    }
    $smarty->assign("arrCalls", $arrCalls);
    
}

function createFieldForm()
{
    $arrOptions = array('val1' => 'Value 1', 'val2' => 'Value 2', 'val3' => 'Value 3');

    $arrFields = array(
            "call001"   => array(      "LABEL"                  => _tr("Call001"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "CHECKBOX",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "call002"   => array(      "LABEL"                  => _tr("Call002"),
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "CHECKBOX",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),

            );
    return $arrFields;
}

function getAction()
{
    if(getParameter("do_selected")) //Get parameter by POST (submit)
        return "do_selected";
    else if(getParameter("save_edit"))
        return "save_edit";
    else if(getParameter("delete")) 
        return "delete";
    else if(getParameter("new_open")) 
        return "view_form";
    else if(getParameter("action")=="view")      //Get parameter by GET (command pattern, links)
        return "view_form";
    else if(getParameter("action")=="view_edit")
        return "view_form";
    else if(count(getParameterRegexp("disc_.*")) > 0)
        return "disconnect_one";
    else
        return "report"; //cancel
}

function getParameterRegexp($pattern) {
  $r = array();
  foreach (array_merge($_POST,$_GET) as $key => $item) {
    if (ereg($pattern,$key)) 
	$r[] = array('key' => $key, 'value' => $item);
  }
  return $r;
}

function runAsteriskCLI($cmd) {
    putenv("TERM=vt100");
    putenv("PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin");
    $badchars = array("'", "`", "\\", ";", "\""); // Strip off any nasty chars.
    $fixedcmd = str_replace($badchars, "", $cmd);
    $ph = popen(stripslashes("asterisk -nrx \"$fixedcmd\""), 'r');
    $res = '';
    while ($line = stream_get_line($ph,1024)) {
	$res .= htmlspecialchars($line);
    }
    pclose($ph); 
    return explode("\n",$res);
}
?>